package org.directwebremoting.servlet;

import java.util.Iterator;
import org.directwebremoting.extend.NamedConverter;
import org.directwebremoting.servlet.BaseDtoAllHandler;
import org.directwebremoting.servlet.DojoModule;
import org.directwebremoting.util.LocalUtil;

public class DojoDtoAllHandler extends BaseDtoAllHandler {

   protected String dojoDwrBaseModulePath;
   protected String dojoDtoBaseModulePath;


   public String generateDtoAllScript(String contextPath, String servletPath) {
      DojoModule mod = new DojoModule(contextPath, servletPath, this.dojoDwrBaseModulePath, "dtoall");
      mod.addRequire(this.dojoDwrBaseModulePath, "engine");
      String engineModule = mod.expandModulePath(this.dojoDwrBaseModulePath, "engine");
      mod.addContent("(function() {\n");
      mod.addContent("  var c;\n");
      mod.addContent("  var addedNow = [];\n");
      Iterator i$ = this.converterManager.getNamedConverterJavaScriptNames().iterator();

      String jsClassName;
      while(i$.hasNext()) {
         jsClassName = (String)i$.next();
         String namedConv = mod.expandModulePath(this.dojoDtoBaseModulePath, jsClassName);
         mod.addContent("\n");
         mod.addContent("  dojo.provide(\"" + namedConv + "\");\n");
         mod.addContent("  if (!" + engineModule + "._mappedClasses[\"" + jsClassName + "\"]) {\n");
         mod.addContent(this.remoter.generateDtoJavaScript(jsClassName, "    ", "c"));
         mod.addContent("    " + engineModule + "._mappedClasses[\"" + jsClassName + "\"] = c;\n");
         mod.addContent("    addedNow[\"" + jsClassName + "\"] = true;\n");
         mod.addContent("  }\n");
         mod.addContent("  dojo.setObject(\"" + namedConv + "\", " + engineModule + "._mappedClasses[\"" + jsClassName + "\"]);\n");
      }

      i$ = this.converterManager.getNamedConverterJavaScriptNames().iterator();

      while(i$.hasNext()) {
         jsClassName = (String)i$.next();
         NamedConverter namedConv1 = this.converterManager.getNamedConverter(jsClassName);
         String jsSuperClassName = namedConv1.getJavascriptSuperClass();
         if(LocalUtil.hasLength(jsSuperClassName)) {
            String classExpression = engineModule + "._mappedClasses[\"" + jsClassName + "\"]";
            String superClassExpression = engineModule + "._mappedClasses[\"" + jsSuperClassName + "\"]";
            mod.addContent("\n");
            mod.addContent("  if (addedNow[\"" + jsClassName + "\"]) {\n");
            mod.addContent(this.remoter.generateDtoInheritanceJavaScript("    ", classExpression, superClassExpression, engineModule + "._delegate"));
            mod.addContent("  }\n");
         }
      }

      mod.addContent("})();\n");
      return mod.toString();
   }

   public void setDojoDwrBaseModulePath(String modulePath) {
      this.dojoDwrBaseModulePath = modulePath;
   }

   public void setDojoDtoBaseModulePath(String modulePath) {
      this.dojoDtoBaseModulePath = modulePath;
   }
}
